<?php
// $Id: ec_recurring.alloc.inc,v 1.5 2009/05/25 07:30:45 gordon Exp $
/**
 * @file
 * Implements the recurring aspects of the allocation interface.
 */

/**
 * Implementation of hook_alloc_get_recurring().
 */
function ec_recurring_alloc_get_recurring($txn) {
  if (isset($txn->recurring) && $txn->recurring) {
    if ($recurring_products = array_filter($txn->items, 'ec_recurring_filter_recurring_products')) {
      // Only use the first recurring product as there should only ever be one recurring product in
      // in a transaction.
      $item = reset($recurring_products);
      
      $recurring = array(
        'price' => $txn->recurring['price'],
        'period' => $item->schedule['numunits'],
        'unit' => $item->schedule['unit'],
      );
      
      if ($item->schedule['cycles'] >= 1) {
        $recurring['repeat'] = $item->schedule['cycles'];
      }
      
      return $recurring;
    }
  }
}

/**
 * Implementation of hook_alloc_update_recurring_payment().
 */
function ec_recurring_alloc_update_recurring_payment($txn, $receipt) {
  if ($recurring_products = array_filter($txn->items, 'ec_recurring_filter_recurring_products')) {
    // Only use the first recurring product as there should only ever be one recurring product in
    // in a transaction.
    $item = reset($recurring_products);
    
    $params = array(
      'ecid' => isset($txn->ecid) ? $txn->ecid : $txn->customer->ecid,
      'items' => array($item->nid => $item),
    );
    
    if ($recurring_txn = ec_checkout_create_transaction('ec_recurring', $params)) {
      $alloc[] = array(
        'type' => 'transaction',
        'id' => $recurring_txn->txnid,
      );
      ec_receipt_allocate($receipt, $alloc);
    }
  }
}